# netbots.tcl v4.05 (3 September 2001)
# Copyright 1998-2001 by slennox <slennox@egghelp.org>
# slennox's eggdrop page - http://www.egghelp.org/

## nocycle.tcl component script v4.05.0 ##

proc cy_check {from keyword arg} {
  global cy_chans cy_gotnotc
  if {$cy_gotnotc} {return 0}
  set notice [join [lrange [split $arg] 1 end]]
  if {$from == ""} {
    if {[string match ":\\*\\*\\* Notice -- server is currently in split-mode" $notice]} {
      set cy_gotnotc 1
      set list [cy_opped] ; set opped [lindex $list 0] ; set nopped [lindex $list 1]
      if {$opped == ""} {
        putlog "nocycle: detected split-mode on my current server - jumping to next server."
        jump
      } else {
        if {$nopped == ""} {return 0}
        foreach chan $nopped {
          if {[string match *-cycle* [channel info $chan]]} {continue}
          lappend cy_chans $chan
          channel set $chan -cycle
        }
        if {$cy_chans == ""} {return 0}
        putlog "nocycle: detected split-mode on my current server ($from). Opped on [join $opped ", "] - switched off cycle for [join $cy_chans ", "]"
      }
    } elseif {[string match ":\\*\\*\\* Notice -- You are in a restricted access mode" $notice]} {
      set cy_gotnotc 1
      set list [cy_opped] ; set opped [lindex $list 0] ; set nopped [lindex $list 1]
      if {$opped == ""} {
        putlog "nocycle: detected restricted mode on my current server - jumping to next server."
        jump
      } else {
        if {$nopped == ""} {return 0}
        foreach chan $nopped {
          if {[string match *-cycle* [channel info $chan]]} {continue}
          lappend cy_chans $chan
          channel set $chan -cycle
        }
        if {$cy_chans == ""} {return 0}
        putlog "nocycle: detected restricted mode on my current server ($from). Opped on [join $opped ", "] - switched off cycle for [join $cy_chans ", "]"
      }
    }
  } elseif {[string match *.* [lindex [split $from !] 0]]} {
    if {[string match ":\\*\\*\\* Notice -- Due to a network split, you can not obtain channel operator status in a new channel at this time." $notice] || [string match ":\\*\\*\\* Channel ops on * are unavailable during split \\*\\*\\*" $notice]} {
      set cy_gotnotc 1
      set list [cy_opped] ; set opped [lindex $list 0] ; set nopped [lindex $list 1]
      if {$opped == ""} {
        putlog "nocycle: detected no_chanops_when_split on my current server ($from). Not opped on any channels - jumping to next server."
        jump
      } else {
        if {$nopped == ""} {return 0}
        foreach chan $nopped {
          if {[string match *-cycle* [channel info $chan]]} {continue}
          lappend cy_chans $chan
          channel set $chan -cycle
        }
        if {$cy_chans == ""} {return 0}
        putlog "nocycle: detected no_chanops_when_split on my current server ($from). Opped on [join $opped ", "] - switched off cycle for [join $cy_chans ", "]"
      }
    }
  }
  return 0
}

proc cy_opped {} {
  set opped "" ; set nopped ""
  foreach chan [channels] {
    if {[botisop $chan]} {
      lappend opped $chan
    } else {
      lappend nopped $chan
    }
  }
  return [list $opped $nopped]
}

proc cy_on {from keyword arg} {
  global cy_chans cy_gotnotc
  set cy_gotnotc 0
  if {$cy_chans == ""} {return 0}
  foreach chan $cy_chans {
    if {![validchan $chan]} {continue}
    channel set $chan +cycle
  }
  set cy_chans ""
  return 0
}

if {![info exists cy_chans]} {
  set cy_chans ""
}
if {![info exists cy_gotnotc]} {
  set cy_gotnotc 0
}

bind raw - NOTICE cy_check
bind raw - 001 cy_on

return "nb_info 4.05.0"
